alias dccarea {
  if (!$window(@hide_dcc)) || ($window(@hide_dcc).h == 0) {
    window -ihpoB +dx @hide_dcc 0 0 2000 100
    Ktools DockWindow $window(@hide_dcc).hwnd > bottom 1
    dccarea_draw
    window -a @hide_dcc
  }
  else {
    window -ihpoB +dx @hide_dcc 0 0 0 0
    Ktools DockWindow $window(@hide_dcc).hwnd > bottom 1
    dccarea_draw
    window -a @hide_dcc
  }
}

alias dccarea_draw {
  if ($window(@hide_dcc)) && ($window(@hide_dcc).h > 1) {
    drawrect -fnr @hide_dcc $color($color(background)) 1 0 0 2000 100
    drawrect -fnr @hide_dcc $col(background) 1 0 0 2000 22
    if ($data(switch_pos) == bottom) {
      drawline -nr @hide_dcc $col(shadow) 1 0 0 2000 0
      drawline -nr @hide_dcc $col(highlight) 1 0 1 2000 1
    }
    ;file nick speed %percent size
    ;30 15 10 35 10
    ;30 45 55 90 100
    var %wp = $calc($window(-2).w / 100)
    drawtext -cnr @hide_dcc $col(text) tahoma 11 5 5 $calc(%wp * 30 - 2) 15 Filename
    drawline -nr @hide_dcc $col(shadow) 1 $calc(%wp * 30) 1 $calc(%wp * 30) 22
    drawline -nr @hide_dcc $col(highlight) 1 $calc(%wp * 30 + 1) 1 $calc(%wp * 30 + 1) 22
    drawtext -cnr @hide_dcc $col(text) tahoma 11 $calc(%wp * 30 + 5) 5 $calc(%wp * 45 - 2) 15 Nickname
    drawline -nr @hide_dcc $col(shadow) 1 $calc(%wp * 45) 1 $calc(%wp * 45) 22
    drawline -nr @hide_dcc $col(highlight) 1 $calc(%wp * 45 + 1) 1 $calc(%wp * 45 + 1) 22
    drawtext -cnr @hide_dcc $col(text) tahoma 11 $calc(%wp * 45 + 5) 5 $calc(%wp * 55 - 2) 15 Speed
    drawline -nr @hide_dcc $col(shadow) 1 $calc(%wp * 55) 1 $calc(%wp * 55) 22
    drawline -nr @hide_dcc $col(highlight) 1 $calc(%wp * 55 + 1) 1 $calc(%wp * 55 + 1) 22
    drawtext -cnr @hide_dcc $col(text) tahoma 11 $calc(%wp * 55 + 5) 5 $calc(%wp * 85 - 2) 15 Percentage Complete
    drawline -nr @hide_dcc $col(shadow) 1 $calc(%wp * 85) 1 $calc(%wp * 85) 22
    drawline -nr @hide_dcc $col(highlight) 1 $calc(%wp * 85 + 1) 1 $calc(%wp * 85 + 1) 22
    drawtext -cnr @hide_dcc $col(text) tahoma 11 $calc(%wp * 85 + 5) 5 $calc(%wp * 100 - 2) 15 Size Rcvd/Total
    drawline -nr @hide_dcc $col(shadow) 1 $calc(%wp * 100) 1 $calc(%wp * 100) 22
    /*
    {
      drawrect -fnr @hide_dcc $col(background) 1 $calc($window(-2).w - 30) 2 29 400
      drawline -nr @hide_dcc $col(highlight) 1 $calc(%wp * 100 + 1) 1 $calc(%wp * 100 + 1) 400  
      drawrect -nr @hide_dcc $col(border) 1 $calc(%wp * 100 + 3) 2 20 20
      drawline -nr @hide_dcc $col(highlight) 1 $calc(%wp * 100 + 4) 20 $calc(%wp * 100 + 4) 3 $calc(%wp * 100 + 22) 3 
      drawline -nr @hide_dcc $col(shadow) 1 $calc(%wp * 100 + 4) 20 $calc(%wp * 100 + 21) 20 $calc(%wp * 100 + 21) 3  
      drawtext -nr @hide_dcc $col(text) webdings 12 $calc(%wp * 100 + 7) 2 r
    }  
    */
    drawline @hide_dcc
    dccarea_list
  }  
}
alias dccarea_list {
  if ($window(@hide_dcc)) && ($window(@hide_dcc).h > 1) {
    if ($g_data(dcc_lstart) > $calc($get(0) + $send(0))) { hadd gui dcc_lstart 1 }
    var %s = $temp(dcc_lstart) , %i = 1
    if (!%s) { %s = 1 }
    var %wp = $calc($window(-2).w / 100)
    drawrect -fnr @hide_dcc $color($color(background)) 1 0 23 $calc(%wp * 100 - 1) 200
    while (%s <= $get(0)) {
      drawtext -nr @hide_dcc $color($color(normal)) Wingdings 10 2 $calc(11 + (%i * 15)) 
      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 14 $calc(10 + (%i * 15)) $get(%s).file
      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 $calc(%wp * 30 + 5) $calc(10 + (%i * 15)) $get(%s)
      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 $calc(%wp * 45 + 5) $calc(10 + (%i * 15)) $round($calc($get(%s).cps / 1024),2) KB/s

      drawrect -nr @hide_dcc $col(border) 1 $calc(%wp * 55 + 5) $calc(10 + (%i * 15)) $calc((%wp * 85 - 2) - (%wp * 55 + 5)) 11
      drawrect -fnr @hide_dcc $color($color(quit)) 1 $calc(%wp * 55 + 6) $calc(11 + (%i * 15)) $floor($calc(((%wp * 85 - 2) - (%wp * 55 + 5)) * $calc($get(%s).rcvd / $get(%s).size))) 9
      ;drawtext -nr @hide_dcc $color($color(normal)) tahoma 8 $calc(%wp * 55 + (((%wp * 85) - (%wp * 55)) / 2) - 15)) $calc(11 + (%i * 15)) $round($calc($get(%s).rcvd / $get(%s).size * 100),2) $+ %

      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 $calc(%wp * 85 + 5) $calc(10 + (%i * 15)) $round($calc($get(%s).rcvd / 1024000),2) / $round($calc($get(%s).size / 1024000),2) MB
      inc %s | inc %i
    }
    if (%s != $g_Data(dcc_lstart)) { %s = 1 }
    else { %s = $calc(%s - $get(0)) }
    while (%s <= $send(0)) {
      drawtext -nr @hide_dcc $color($color(normal)) Wingdings 10 2 $calc(11 + (%i * 15)) 
      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 14 $calc(10 + (%i * 15)) $send(%s).file
      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 $calc(%wp * 30 + 5) $calc(10 + (%i * 15)) $send(%s)
      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 $calc(%wp * 45 + 5) $calc(10 + (%i * 15)) $round($calc($send(%s).cps / 1024),2) KB/s

      drawrect -nr @hide_dcc $col(border) 1 $calc(%wp * 55 + 5) $calc(10 + (%i * 15)) $calc((%wp * 85 - 2) - (%wp * 55 + 5)) 11
      drawrect -fnr @hide_dcc $color($color(quit)) 1 $calc(%wp * 55 + 6) $calc(11 + (%i * 15)) $floor($calc(((%wp * 85 - 2) - (%wp * 55 + 5)) * $calc($send(%s).sent / $send(%s).size))) 9
      ;drawtext -nr @hide_dcc $color($color(normal)) tahoma 8 $calc(%wp * 55 + (((%wp * 85) - (%wp * 55)) / 2) - 15)) $calc(11 + (%i * 15)) $round($calc($send(%s).sent / $send(%s).size * 100),2) $+ %

      drawtext -nr @hide_dcc $color($color(normal)) tahoma 9 $calc(%wp * 85 + 5) $calc(10 + (%i * 15)) $round($calc($send(%s).sent / 1024000),2) / $round($calc($send(%s).size / 1024000),2) MB
      inc %s | inc %i
    }
    if (%i != 1) && (!$timer(dcclist)) { .timerdcclist -im 1 400 dccarea_list }
    if (%i > 5) {
      hinc temp dcc_temp 
      if ($temp(dcc_temp) > 6) {
        hadd temp dcc_temp 0
        hinc temp dcc_lstart
        if ($temp(dcc_lstart) > $calc($get(0) + $send(0))) { hadd temp dcc_lstart 1 }
      }
    }
    drawline @hide_dcc
  }
  else { .timerdcclist off }
}
